nsim<-1000
res<-matrix(NA,nsim,2)
for(ii in 1:nsim){
  x<-rnorm(500)
  y<-2*x+rnorm(500,sd=.5)
  ismar<-sapply(x,
                FUN=function(xx){
                  yy<-xx
                  prob<-pnorm(1.2*yy-.5)
                  res<-sample(c(T,F),size=1,prob = c(prob,1-prob))
                  return(res)})
  ymar<-y;ymar[ismar]<-NA
  res.lm<-lm(ymar[!ismar]~x[!ismar])
  ystoch<-ymar
  ystoch[ismar]<- cbind(1,x[ismar])%*%res.lm$coefficients+rnorm(sum(ismar),sd=summary(res.lm)$sigma)
  res[ii,]<-c(mean(ystoch),
              (0<=(mean(ystoch)+qt(p = 0.975,df=499)*sd(ystoch)/sqrt(500))&(
                0>=(mean(ystoch)-qt(p = 0.975,df=499)*sd(ystoch)/sqrt(500)))))
}

par(mfrow=c(1,2),mar=c(4, 5, 3, 1) + 0.1)
plot(cumsum(res[,1])/(1:nsim),ylab=expression(bar(y[imp])),xlab="nb sim");abline(h=0,col=2)
plot(cumsum(res[,2])/(1:nsim),ylab="coverage",xlab="nb sim");abline(h=0.95,col=2)
