library(mice)
#simulation data
x<-rnorm(500)
y<-2*x+rnorm(500,sd=.5)
ismar<-sapply(x,
              FUN=function(xx){
                yy<-xx
                prob<-pnorm(1.2*yy-.5)
                res<-sample(c(T,F),size=1,prob = c(prob,1-prob))
                return(res)})
ymar<-y;ymar[ismar]<-NA
don<-cbind.data.frame(x,ymar)

#imputation
res.mice<-mice(don,m=3,method="norm.boot")

#extraction d'un tableau
data1<-complete(res.mice,1)
summary(data1)

#analyse
res.with<-with(res.mice,lm(y~1))

#aggregation
res.pool<-pool(res.with)
summary(res.pool)
